# Generated by Django 4.2.4 on 2023-08-14 18:42

import aleksis.core.managers
from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    dependencies = [
        ("core", "0052_site_related_name"),
        ("lesrooster", "0002_timeboundcourseconfig"),
    ]

    operations = [
        migrations.CreateModel(
            name="TimeGrid",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True, primary_key=True, serialize=False, verbose_name="ID"
                    ),
                ),
                (
                    "managed_by_app_label",
                    models.CharField(
                        blank=True,
                        editable=False,
                        max_length=255,
                        verbose_name="App label of app responsible for managing this instance",
                    ),
                ),
                ("extended_data", models.JSONField(default=dict, editable=False)),
                (
                    "group",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="time_grids",
                        to="core.group",
                        verbose_name="Group",
                    ),
                ),
                (
                    "validity_range",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="time_grids",
                        to="lesrooster.validityrange",
                        verbose_name="Linked validity range",
                    ),
                ),
            ],
            options={
                "verbose_name": "Time Grid",
                "verbose_name_plural": "Time Grids",
            },
            managers=[
                ("objects", aleksis.core.managers.AlekSISBaseManager()),
            ],
        ),
        migrations.AddConstraint(
            model_name="timegrid",
            constraint=models.UniqueConstraint(
                fields=("validity_range", "group"), name="lr_unique_validity_range_group_time_grid"
            ),
        ),
    ]
